Index: palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3297)
+++ palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3298)
@@ -304,761 +485,296 @@
 !------------------------------------------------------------------------------!
 
- SUBROUTINE chem_boundary_conds( mode )                                           
-                                                                                  
-    USE control_parameters,                                                    &  
-        ONLY:  bc_radiation_l, bc_radiation_n, bc_radiation_r, bc_radiation_s
-
-    USE indices,                                                               &  
-        ONLY:  nxl, nxr, nzt
-                                                                                  
-    USE arrays_3d,                                                             &     
-        ONLY:  dzu                                                
-
-    USE surface_mod,                                                           &
-        ONLY:  bc_h                                                           
-
-    CHARACTER (len=*), INTENT(IN) :: mode
-    INTEGER(iwp) ::  i                                                            !< grid index x direction.
-    INTEGER(iwp) ::  j                                                            !< grid index y direction.
-    INTEGER(iwp) ::  k                                                            !< grid index z direction.
-    INTEGER(iwp) ::  kb                                                           !< variable to set respective boundary value, depends on facing. 
-    INTEGER(iwp) ::  l                                                            !< running index boundary type, for up- and downward-facing walls.
-    INTEGER(iwp) ::  m                                                            !< running index surface elements.
-    INTEGER(iwp) ::  lsp                                                          !< running index for chem spcs.
-
-
-    SELECT CASE ( TRIM( mode ) )        
-       CASE ( 'init' )     
-          DO lsp = 1, nspec            
-            IF ( surface_csflux(lsp) == 9999999.9_wp )  THEN
-                 constant_csflux(lsp) = .FALSE.            
-            ENDIF
-          ENDDO
-
-          IF ( bc_cs_b == 'dirichlet' )    THEN
-             ibc_cs_b = 0 
-          ELSEIF ( bc_cs_b == 'neumann' )  THEN
-             ibc_cs_b = 1 
-          ELSE
-!             message_string = 'unknown boundary condition: bc_cs_b ="' // TRIM( bc_cs_b ) // '"'  ! bK commented
-             CALL message( 'chem_boundary_conds', 'CM0010', 1, 2, 0, 6, 0 )     !< chemistry_model_mod should have special error numbers --> "CHEM###",
-          ENDIF                                                                  
-!
-!--       Set Integer flags and check for possible erroneous settings for top
-!--       boundary condition. bK added *_cs_* here.
-          IF ( bc_cs_t == 'dirichlet' )             THEN
-             ibc_cs_t = 0 
-          ELSEIF ( bc_cs_t == 'neumann' )           THEN
-             ibc_cs_t = 1
-          ELSEIF ( bc_cs_t == 'initial_gradient' )  THEN
-             ibc_cs_t = 2
-          ELSEIF ( bc_cs_t == 'nested' )            THEN          
-             ibc_cs_t = 3
-          ELSE
-!            message_string = 'unknown boundary condition: bc_c_t ="' // TRIM( bc_cs_t ) // '"'  
-             CALL message( 'check_parameters', 'CM0011', 1, 2, 0, 6, 0 )
-          ENDIF
-
-      
-       CASE ( 'set_bc_bottomtop' )                   
-!--      Bottom boundary condtions for chemical species      
-          DO lsp = 1, nspec                                                      
-             IF ( ibc_cs_b == 0 ) THEN                   
-                DO l = 0, 1 
-!--             Set index kb: For upward-facing surfaces (l=0), kb=-1, i.e.
-!--             the chem_species(nsp)%conc_p value at the topography top (k-1)
-!--             is set; for downward-facing surfaces (l=1), kb=1, i.e. the 
-!--             value at the topography bottom (k+1) is set. 
-
-                   kb = MERGE( -1, 1, l == 0 )
-                   !$OMP PARALLEL DO PRIVATE( i, j, k )
-                   DO m = 1, bc_h(l)%ns
-                      i = bc_h(l)%i(m)            
-                      j = bc_h(l)%j(m)
-                      k = bc_h(l)%k(m)
-                      chem_species(lsp)%conc_p(k+kb,j,i) = chem_species(lsp)%conc(k+kb,j,i) 
-                   ENDDO                                        
-                ENDDO                                       
-          
-             ELSEIF ( ibc_cs_b == 1 ) THEN
-         ! in boundary_conds there is som extra loop over m here for passive tracer
-                DO l = 0, 1
-                   kb = MERGE( -1, 1, l == 0 )
-                   !$OMP PARALLEL DO PRIVATE( i, j, k )                                           
-                   DO m = 1, bc_h(l)%ns
-                      i = bc_h(l)%i(m)            
-                      j = bc_h(l)%j(m)
-                      k = bc_h(l)%k(m)
-                      chem_species(lsp)%conc_p(k+kb,j,i) = chem_species(lsp)%conc_p(k,j,i)
-
-!< @todo: chem_species(nsp)%conc_p(k+kb,j,i) = chem_species(nsp)%conc(k+kb,j,i),    &
-!<  pls loop over nsp=1, NSPEC.
-!< @todo: We should also think about the possibility to have &
-!< individual boundary conditions for each species? This means, bc_cs_b,       &
-!< bc_cs_t, ibc_cs_b, ibc_cs_t would need to be added to TYPE chem_species(nsp)%,   &
-!< and the loop over nsp would have to be put outside of this IF-clause.
-!< i think its better we keep the same bonundary cond i.e. dirichlet or neumann
-!< for all chem spcs. ... !bK
-
+    SUBROUTINE chem_boundary_conds( mode )                                           
+                                                                                     
+       USE control_parameters,                                                    &  
+          ONLY:  air_chemistry, bc_radiation_l, bc_radiation_n, bc_radiation_r,  &
+                 bc_radiation_s                
+       USE indices,                                                               &  
+          ONLY:  nxl, nxr,  nxlg, nxrg, nyng, nysg, nzt                              
+                                                                                     
+
+       USE arrays_3d,                                                             &     
+          ONLY:  dzu                                                
+       USE surface_mod,                                                           &
+          ONLY:  bc_h                                                           
+
+       CHARACTER (len=*), INTENT(IN) :: mode
+       INTEGER(iwp) ::  i                                                            !< grid index x direction.
+       INTEGER(iwp) ::  j                                                            !< grid index y direction.
+       INTEGER(iwp) ::  k                                                            !< grid index z direction.
+       INTEGER(iwp) ::  kb                                                           !< variable to set respective boundary value, depends on facing. 
+       INTEGER(iwp) ::  l                                                            !< running index boundary type, for up- and downward-facing walls.
+       INTEGER(iwp) ::  m                                                            !< running index surface elements.
+       INTEGER(iwp) ::  lsp                                                          !< running index for chem spcs.
+       INTEGER(iwp) ::  lph                                                          !< running index for photolysis frequencies
+
+
+       SELECT CASE ( TRIM( mode ) )        
+          CASE ( 'init' )
+
+             IF ( bc_cs_b == 'dirichlet' )    THEN
+                ibc_cs_b = 0 
+             ELSEIF ( bc_cs_b == 'neumann' )  THEN
+                ibc_cs_b = 1 
+             ELSE
+                message_string = 'unknown boundary condition: bc_cs_b ="' // TRIM( bc_cs_b ) // '"'  
+                CALL message( 'chem_boundary_conds', 'CM0429', 1, 2, 0, 6, 0 )     !<
+             ENDIF                                                                  
+!
+!--          Set Integer flags and check for possible erroneous settings for top
+!--          boundary condition. 
+             IF ( bc_cs_t == 'dirichlet' )             THEN
+                ibc_cs_t = 0 
+             ELSEIF ( bc_cs_t == 'neumann' )           THEN
+                ibc_cs_t = 1
+             ELSEIF ( bc_cs_t == 'initial_gradient' )  THEN
+                ibc_cs_t = 2
+             ELSEIF ( bc_cs_t == 'nested' )            THEN          
+                ibc_cs_t = 3
+             ELSE
+                message_string = 'unknown boundary condition: bc_c_t ="' // TRIM( bc_cs_t ) // '"'      
+                CALL message( 'check_parameters', 'CM0430', 1, 2, 0, 6, 0 )
+             ENDIF
+
+         
+          CASE ( 'set_bc_bottomtop' )                   
+!--          Bottom boundary condtions for chemical species      
+             DO lsp = 1, nspec                                                      
+                IF ( ibc_cs_b == 0 ) THEN                   
+                   DO l = 0, 1 
+!--                Set index kb: For upward-facing surfaces (l=0), kb=-1, i.e.
+!--                the chem_species(nspec)%conc_p value at the topography top (k-1)
+!--                is set; for downward-facing surfaces (l=1), kb=1, i.e. the 
+!--                value at the topography bottom (k+1) is set. 
+
+                      kb = MERGE( -1, 1, l == 0 )
+                      !$OMP PARALLEL DO PRIVATE( i, j, k )
+                      DO m = 1, bc_h(l)%ns
+                         i = bc_h(l)%i(m)            
+                         j = bc_h(l)%j(m)
+                         k = bc_h(l)%k(m)
+                         chem_species(lsp)%conc_p(k+kb,j,i) = chem_species(lsp)%conc(k+kb,j,i) 
+                      ENDDO                                        
+                   ENDDO                                       
+             
+                ELSEIF ( ibc_cs_b == 1 ) THEN
+!--             in boundary_conds there is som extra loop over m here for passive tracer
+                   DO l = 0, 1
+                      kb = MERGE( -1, 1, l == 0 )
+                      !$OMP PARALLEL DO PRIVATE( i, j, k )                                           
+                      DO m = 1, bc_h(l)%ns
+                         i = bc_h(l)%i(m)            
+                         j = bc_h(l)%j(m)
+                         k = bc_h(l)%k(m)
+                         chem_species(lsp)%conc_p(k+kb,j,i) = chem_species(lsp)%conc_p(k,j,i)
+
+                      ENDDO
+                   ENDDO
+                ENDIF
+          ENDDO    ! end lsp loop  
+
+!--    Top boundary conditions for chemical species - Should this not be done for all species?
+             IF ( ibc_cs_t == 0 )  THEN                    
+                DO lsp = 1, nspec
+                   chem_species(lsp)%conc_p(nzt+1,:,:) = chem_species(lsp)%conc(nzt+1,:,:)        
+                ENDDO
+             ELSEIF ( ibc_cs_t == 1 )  THEN
+                DO lsp = 1, nspec
+                   chem_species(lsp)%conc_p(nzt+1,:,:) = chem_species(lsp)%conc_p(nzt,:,:)
+                ENDDO
+             ELSEIF ( ibc_cs_t == 2 )  THEN
+                DO lsp = 1, nspec
+                   chem_species(lsp)%conc_p(nzt+1,:,:) = chem_species(lsp)%conc_p(nzt,:,:) + bc_cs_t_val(lsp) * dzu(nzt+1)
+                ENDDO
+             ENDIF
+!
+          CASE ( 'set_bc_lateral' )                       
+!--             Lateral boundary conditions for chem species at inflow boundary
+!--             are automatically set when chem_species concentration is
+!--             initialized. The initially set value at the inflow boundary is not
+!--             touched during time integration, hence, this boundary value remains
+!--             at a constant value, which is the concentration that flows into the
+!--             domain.                                                           
+!--             Lateral boundary conditions for chem species at outflow boundary 
+
+             IF ( bc_radiation_s )  THEN
+                DO lsp = 1, nspec
+                   chem_species(lsp)%conc_p(:,nys-1,:) = chem_species(lsp)%conc_p(:,nys,:)
+                ENDDO
+             ELSEIF ( bc_radiation_n )  THEN
+                DO lsp = 1, nspec
+                   chem_species(lsp)%conc_p(:,nyn+1,:) = chem_species(lsp)%conc_p(:,nyn,:)
+                ENDDO
+             ELSEIF ( bc_radiation_l )  THEN
+                DO lsp = 1, nspec
+                   chem_species(lsp)%conc_p(:,:,nxl-1) = chem_species(lsp)%conc_p(:,:,nxl)
+                ENDDO
+             ELSEIF ( bc_radiation_r )  THEN
+                DO lsp = 1, nspec
+                   chem_species(lsp)%conc_p(:,:,nxr+1) = chem_species(lsp)%conc_p(:,:,nxr)
+                ENDDO
+             ENDIF
+            
+       END SELECT
+
+    END SUBROUTINE chem_boundary_conds
+
+!
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Boundary conditions for prognostic variables in chemistry: decycling in the 
+!> x-direction
+!-----------------------------------------------------------------------------
+    SUBROUTINE chem_boundary_conds_decycle (cs_3d, cs_pr_init )
+       USE pegrid,                                                             &
+                 ONLY: myid
+
+       IMPLICIT NONE 
+       INTEGER(iwp) ::  boundary !< 
+       INTEGER(iwp) ::  ee !<
+       INTEGER(iwp) ::  copied !< 
+       INTEGER(iwp) ::  i !< 
+       INTEGER(iwp) ::  j !< 
+       INTEGER(iwp) ::  k !< 
+       INTEGER(iwp) ::  ss !< 
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  cs_pr_init
+       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  cs_3d
+       REAL(wp) ::  flag !< flag to mask topography grid points
+
+       flag = 0.0_wp
+
+       
+!--    Left and right boundaries
+       IF ( decycle_chem_lr  .AND.  bc_lr_cyc )  THEN
+
+          DO  boundary = 1, 2
+
+             IF ( decycle_method(boundary) == 'dirichlet' )  THEN
+!    
+!--             Initial profile is copied to ghost and first three layers          
+                ss = 1
+                ee = 0
+                IF ( boundary == 1  .AND.  nxl == 0 )  THEN
+                   ss = nxlg
+                   ee = nxl+2
+                ELSEIF ( boundary == 2  .AND.  nxr == nx )  THEN
+                   ss = nxr-2
+                   ee = nxrg
+                ENDIF
+
+                DO  i = ss, ee
+                   DO  j = nysg, nyng
+                      DO  k = nzb+1, nzt
+                         flag = MERGE( 1.0_wp, 0.0_wp,                            &
+                                       BTEST( wall_flags_0(k,j,i), 0 ) )
+                         cs_3d(k,j,i) = cs_pr_init(k) * flag
+                      ENDDO
                    ENDDO
                 ENDDO
-             ENDIF
-          ENDDO    ! end lsp loop  
-
-!--    Top boundary conditions for chemical species - Should this not be done for all species?
-          IF ( ibc_cs_t == 0 )  THEN                    
-             DO lsp = 1, nspec
-                chem_species(lsp)%conc_p(nzt+1,:,:) = chem_species(lsp)%conc(nzt+1,:,:)        
-             ENDDO
-          ELSEIF ( ibc_cs_t == 1 )  THEN
-             DO lsp = 1, nspec
-                chem_species(lsp)%conc_p(nzt+1,:,:) = chem_species(lsp)%conc_p(nzt,:,:)
-             ENDDO
-          ELSEIF ( ibc_cs_t == 2 )  THEN
-             DO lsp = 1, nspec
-                chem_species(lsp)%conc_p(nzt+1,:,:) = chem_species(lsp)%conc_p(nzt,:,:) + bc_cs_t_val(lsp) * dzu(nzt+1)
-             ENDDO
-                                    !@todo: bc_cs_t_val needs to be calculated,    
-                                    !see bc_pt_t_val = ( pt_init(nzt+1) - pt_init(nzt) ) / dzu(nzt+1) 
-                                    !(in time_integration). pt_init would be the counterpart to
-                                    !chem_species(i)%conc_pr_init (see kchem_driver_FKa1408.f90 of my 
-                                    !"Hints: prescribing initial concentration.
-          ENDIF
-!
-       CASE ( 'set_bc_lateral' )                       ! bK commented it
-!--          Lateral boundary conditions for chem species at inflow boundary
-!--          are automatically set when chem_species concentration is
-!--          initialized. The initially set value at the inflow boundary is not
-!--          touched during time integration, hence, this boundary value remains
-!--          at a constant value, which is the concentration that flows into the
-!--          domain.                                                           
-!--          Lateral boundary conditions for chem species at outflow boundary 
-
-          IF ( bc_radiation_s )  THEN
-             DO lsp = 1, nspec
-                chem_species(lsp)%conc_p(:,nys-1,:) = chem_species(lsp)%conc_p(:,nys,:)
-             ENDDO
-          ELSEIF ( bc_radiation_n )  THEN
-             DO lsp = 1, nspec
-                chem_species(lsp)%conc_p(:,nyn+1,:) = chem_species(lsp)%conc_p(:,nyn,:)
-             ENDDO
-          ELSEIF ( bc_radiation_l )  THEN
-             DO lsp = 1, nspec
-                chem_species(lsp)%conc_p(:,:,nxl-1) = chem_species(lsp)%conc_p(:,:,nxl)
-             ENDDO
-          ELSEIF ( bc_radiation_r )  THEN
-             DO lsp = 1, nspec
-                chem_species(lsp)%conc_p(:,:,nxr+1) = chem_species(lsp)%conc_p(:,:,nxr)
-             ENDDO
-          ENDIF
-         
-    END SELECT
-
- END SUBROUTINE chem_boundary_conds
-!
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Subroutine defining initial vertical profiles of chemical species (given by
-!> namelist parameters chem_profiles and chem_heights)  --> which should work
-!> analogue to parameters u_profile, v_profile and uv_heights)
-!------------------------------------------------------------------------------!
- SUBROUTINE chem_init_profiles              !< SUBROUTINE is called from chem_init in case of 
-                                            !< TRIM( initializing_actions ) /= 'read_restart_data'
-                                            !< We still need to see what has to be done in case of restart run
-    USE chem_modules
-
-    IMPLICIT NONE
-
-!-- Local variables
-    INTEGER ::  lsp        !< running index for number of species in derived data type species_def
-    INTEGER ::  lsp_pr     !< running index for number of species in cs_names, cs_profiles etc
-    INTEGER ::  lpr_lev    !< running index for profile level for each chem spcs. 
-!    INTEGER ::  npr_lev    !< the next available profile lev
-
-!-----------------
-!-- To prescribe/initialize a vertically constant  'cs_profile', another parameter
-!-- "cs_surface" is introduced. If "cs_profile" and "cs_heights" are prescribed,
-!-- their values will override the constant profile given by "cs_surface".
-
-!     IF ( TRIM( initializing_actions ) /= 'read_restart_data' )  THEN 
-       lsp_pr = 1
-       DO  WHILE ( TRIM( cs_name( lsp_pr ) ) /= 'novalue' )   !'novalue' is the default
-          DO  lsp = 1, nspec                                !
-!--          Create initial profile (conc_pr_init) for each chemical species
-             IF ( TRIM( chem_species(lsp)%name ) == TRIM( cs_name(lsp_pr) ) )  THEN   !
-!                IF ( cs_profile(1,1) == 9999999.9_wp ) THEN
-!--               Set a vertically constant profile based on the surface conc (cs_surface(lsp_pr)) of each species
-                  DO lpr_lev = 0, nzt+1
-                     chem_species(lsp)%conc_pr_init(lpr_lev) = cs_surface(lsp_pr)
-                  ENDDO
-
-!                ELSE
-!                   IF ( cs_heights(lsp,1) /= 0.0_wp )  THEN
-!                      message_string = 'cs_heights(1,1) must be 0.0'
-!                      CALL message( 'chem_check_parameters', 'CM0012', 1, 2, 0, 6, 0 )
-!                   ENDIF
-!  
-!                   IF ( omega /= 0.0_wp )  THEN
-!                      message_string = 'Coriolis force must be switched off (by setting omega=0.0)' //  &
-!                                       ' when prescribing the forcing by u_profile and v_profile'
-!                      CALL message( 'check_parameters', 'PA0347', 1, 2, 0, 6, 0 )
-!                   ENDIF
-!  
-!                   use_prescribed_profile_data = .TRUE.
-! 
-!                   npr_lev = 1
-! !                  chem_sddpecies(lsp)%conc_pr_init(0) = 0.0_wp
-!                   DO  lpr_lev = 1, nz+1
-!                      IF ( npr_lev < 100 )  THEN
-!                         DO  WHILE ( cs_heights(lsp, npr_lev+1) <= zu(lpr_lev) )
-!                            npr_lev = npr_lev + 1
-!                            IF ( npr_lev == 100 )  EXIT
-!                         ENDDO
-!                      ENDIF
-!  
-!                      IF ( npr_lev < 100  .AND.  cs_heights(lsp, npr_lev + 1) /= 9999999.9_wp )  THEN
-!                         chem_species(lsp)%conc_pr_init(lpr_lev) = cs_profile(lsp, npr_lev) +         &
-!                                                 ( zu(lpr_lev) - cs_heights(lsp, npr_lev) ) /         &
-!                                                 ( cs_heights(lsp, npr_lev + 1) - cs_heights(lsp, npr_lev ) ) * &
-!                                                 ( cs_profile(lsp, npr_lev + 1) - cs_profile(lsp, npr_lev ) )
-!                      ELSE
-!                         chem_species(lsp)%conc_pr_init(lpr_lev) = cs_profile(lsp, npr_lev)
-!                      ENDIF
-!                   ENDDO
-!                ENDIF
-!-- If a profile is prescribed explicity using cs_profiles and cs_heights, we then have to fill the 
-!-- chem_species(lsp)%conc_pr_init for the specific "lsp" based on the cs_profiles(lsp_pr,:) 
-!-- and cs_heights(lsp_pr,:). 
+
+           ELSEIF ( decycle_method(boundary) == 'neumann' )  THEN
+!
+!--             The value at the boundary is copied to the ghost layers to simulate
+!--             an outlet with zero gradient
+                ss = 1
+                ee = 0
+                IF ( boundary == 1  .AND.  nxl == 0 )  THEN
+                   ss = nxlg
+                   ee = nxl-1
+                   copied = nxl
+                ELSEIF ( boundary == 2  .AND.  nxr == nx )  THEN
+                   ss = nxr+1
+                   ee = nxrg
+                   copied = nxr
+                ENDIF
+
+                 DO  i = ss, ee
+                   DO  j = nysg, nyng
+                      DO  k = nzb+1, nzt
+                         flag = MERGE( 1.0_wp, 0.0_wp,                            &
+                                       BTEST( wall_flags_0(k,j,i), 0 ) )
+                        cs_3d(k,j,i) = cs_3d(k,j,copied) * flag
+                      ENDDO
+                   ENDDO
+                ENDDO
+
+             ELSE
+                WRITE(message_string,*)                                           &
+                                    'unknown decycling method: decycle_method (', &
+                        boundary, ') ="' // TRIM( decycle_method(boundary) ) // '"'
+                CALL message( 'chem_boundary_conds_decycle', 'CM0431',           &
+                              1, 2, 0, 6, 0 )
              ENDIF
           ENDDO
-          lsp_pr = lsp_pr + 1
-       ENDDO
-!     ELSE
-!       IF (chem_debug1 ) print*,'code to be added for initializing_actions == read_restart_data'   !bK
-!     ENDIF
-
-!-- Now, go back to chem_init and use the contents of chem_species(lsp)%conc_pr_init to
-!-- initialize the 3D conc arrays, as it is currently taken care of in chem_set_constant_values.
-!-- After initializing the 3D arrays, these can be used to set the boundary conditions in the
-!-- subroutine kchem_boundary_conds, which should be called from boundary_conds.f90.
-
-
- END SUBROUTINE chem_init_profiles
-!
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Subroutine initializating chemistry_model_mod
-!------------------------------------------------------------------------------!
-   SUBROUTINE chem_init
-
-      USE pegrid
-
-    IMPLICIT   none
-!-- local variables
-    INTEGER                 :: i,j               !< running index for for horiz numerical grid points
-    INTEGER                 :: lsp               !< running index for chem spcs
-    INTEGER                 :: lpr_lev           !< running index for chem spcs profile level
-!
-!-- NOPOINTER version not implemented yet
-! #if defined( __nopointer )
-!     message_string = 'The chemistry module only runs with POINTER version'
-!     CALL message( 'chemistry_model_mod', 'CM0001', 1, 2, 0, 6, 0 )      
-! #endif
-!
-!-- Allocate memory for chemical species
-    ALLOCATE( chem_species(nspec) )
-    ALLOCATE( spec_conc_1 (nzb:nzt+1,nysg:nyng,nxlg:nxrg,nspec) )
-    ALLOCATE( spec_conc_2 (nzb:nzt+1,nysg:nyng,nxlg:nxrg,nspec) )
-    ALLOCATE( spec_conc_3 (nzb:nzt+1,nysg:nyng,nxlg:nxrg,nspec) )
-    ALLOCATE( spec_conc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nspec) ) 
-    ALLOCATE( phot_frequen(nphot) ) 
-    ALLOCATE( freq_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nphot) )
-    ALLOCATE( bc_cs_t_val(nspec) )
-!
-!-- Initialize arrays
-    spec_conc_1 (:,:,:,:) = 0.0_wp
-    spec_conc_2 (:,:,:,:) = 0.0_wp
-    spec_conc_3 (:,:,:,:) = 0.0_wp
-    spec_conc_av(:,:,:,:) = 0.0_wp
-
-
-    DO lsp = 1, nspec
-       chem_species(lsp)%name    = spc_names(lsp)
-
-       chem_species(lsp)%conc   (nzb:nzt+1,nysg:nyng,nxlg:nxrg)       => spec_conc_1 (:,:,:,lsp)
-       chem_species(lsp)%conc_p (nzb:nzt+1,nysg:nyng,nxlg:nxrg)       => spec_conc_2 (:,:,:,lsp)
-       chem_species(lsp)%tconc_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg)       => spec_conc_3 (:,:,:,lsp)
-       chem_species(lsp)%conc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg)       => spec_conc_av(:,:,:,lsp)     
-
-       ALLOCATE (chem_species(lsp)%cssws_av(nysg:nyng,nxlg:nxrg))                   
-       chem_species(lsp)%cssws_av    = 0.0_wp
-!
-!--    (todo (FK): This needs to be revised. This block must go somewhere else)                                         
-!      IF ( ws_scheme_sca )  THEN                                                
-          ALLOCATE (chem_species(lsp)%flux_s_cs(nzb+1:nzt,0:threads_per_task-1))   
-          ALLOCATE (chem_species(lsp)%diss_s_cs(nzb+1:nzt,0:threads_per_task-1))   
-          ALLOCATE (chem_species(lsp)%flux_l_cs(nzb+1:nzt,nys:nyn,0:threads_per_task-1)) 
-          ALLOCATE (chem_species(lsp)%diss_l_cs(nzb+1:nzt,nys:nyn,0:threads_per_task-1))   
-          chem_species(lsp)%flux_s_cs = 0.0_wp                                     
-          chem_species(lsp)%flux_l_cs = 0.0_wp                                     
-          chem_species(lsp)%diss_s_cs = 0.0_wp                                      
-          chem_species(lsp)%diss_l_cs = 0.0_wp                                     
-!      ENDIF         
-!
-!--   Allocate memory for initial concentration profiles
-!--   (concentration values come from namelist)
-!--   (todo (FK): Because of this, chem_init is called in palm before
-!--               check_parameters, since conc_pr_init is used there.
-!--               We have to find another solution since chem_init should
-!--               eventually be called from init_3d_model!!)
-      ALLOCATE ( chem_species(lsp)%conc_pr_init(0:nz+1) )
-      chem_species(lsp)%conc_pr_init(:) = 0.0_wp
-
-    ENDDO
-
-!
-!-- Set initial concentration of profiles prescribed by parameters cs_profile
-!-- and cs_heights in the namelist &chemistry_parameters
-!-- (todo (FK): chem_init_profiles not ready yet, has some bugs)
-!     CALL chem_init_profiles
-!
-!-- Initialize model variables
-
-
-    IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .AND.            &
-         TRIM( initializing_actions ) /= 'cyclic_fill' )  THEN
-
-
-!--    First model run of a possible job queue.
-!--    Initial profiles of the variables must be computes.
-       IF ( INDEX( initializing_actions, 'set_1d-model_profiles' ) /= 0 )  THEN
-!            CALL location_message( 'initializing with 1D model profiles', .FALSE. )
-!
-!          CALL init_1d_model    ...... decide to call or not later     !bK
-
-!--        Transfer initial profiles to the arrays of the 3D model
-          DO lsp = 1, nspec
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO lpr_lev = 1, nz + 1
-                      chem_species(lsp)%conc(lpr_lev,j,i) = chem_species(lsp)%conc_pr_init(lpr_lev)
+       ENDIF
+
+       
+!--    South and north boundaries
+       IF ( decycle_chem_ns  .AND.  bc_ns_cyc )  THEN
+
+          DO  boundary = 3, 4
+
+             IF ( decycle_method(boundary) == 'dirichlet' )  THEN
+!    
+!--             Initial profile is copied to ghost and first three layers          
+                ss = 1
+                ee = 0
+                IF ( boundary == 3  .AND.  nys == 0 )  THEN
+                   ss = nysg
+                   ee = nys+2
+                ELSEIF ( boundary == 4  .AND.  nyn == ny )  THEN
+                   ss = nyn-2
+                   ee = nyng
+                ENDIF
+
+                DO  i = nxlg, nxrg
+                   DO  j = ss, ee
+                      DO  k = nzb+1, nzt
+                         flag = MERGE( 1.0_wp, 0.0_wp,                            &
+                                       BTEST( wall_flags_0(k,j,i), 0 ) )
+                         cs_3d(k,j,i) = cs_pr_init(k) * flag
+                      ENDDO
                    ENDDO
                 ENDDO
-             ENDDO   
+       
+       
+           ELSEIF ( decycle_method(boundary) == 'neumann' )  THEN
+!
+!--             The value at the boundary is copied to the ghost layers to simulate
+!--             an outlet with zero gradient
+                ss = 1
+                ee = 0
+                IF ( boundary == 3  .AND.  nys == 0 )  THEN
+                   ss = nysg
+                   ee = nys-1
+                   copied = nys
+                ELSEIF ( boundary == 4  .AND.  nyn == ny )  THEN
+                   ss = nyn+1
+                   ee = nyng
+                   copied = nyn
+                ENDIF
+
+                 DO  i = nxlg, nxrg
+                   DO  j = ss, ee
+                      DO  k = nzb+1, nzt
+                         flag = MERGE( 1.0_wp, 0.0_wp,                            &
+                                       BTEST( wall_flags_0(k,j,i), 0 ) )
+                         cs_3d(k,j,i) = cs_3d(k,copied,i) * flag
+                      ENDDO
+                   ENDDO
+                ENDDO
+
+             ELSE
+                WRITE(message_string,*)                                           &
+                                    'unknown decycling method: decycle_method (', &
+                        boundary, ') ="' // TRIM( decycle_method(boundary) ) // '"'
+                CALL message( 'chem_boundary_conds_decycle', 'CM0432',           &
+                              1, 2, 0, 6, 0 )
+             ENDIF
           ENDDO
-       
-       ELSEIF ( INDEX(initializing_actions, 'set_constant_profiles') /= 0 )    &
-       THEN
-!           CALL location_message( 'initializing with constant profiles', .FALSE. )
-
-
-
-!--       Set initial horizontal velocities at the lowest computational grid 
-!--       levels to zero in order to avoid too small time steps caused by the 
-!--       diffusion limit in the initial phase of a run (at k=1, dz/2 occurs
-!--       in the limiting formula!).
-
-          DO lsp = 1, nspec 
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   chem_species(lsp)%conc(:,j,i) = chem_species(lsp)%conc_pr_init    !ITS THERE bK
-                ENDDO
-             ENDDO
-          ENDDO
-
-!        ELSEIF ( INDEX(initializing_actions, 'by_user') /= 0 )                  &
-!        THEN
-!           CALL location_message( 'initializing by user', .FALSE. )
-!
-!--       Initialization will completely be done by the user
-!--       (FK: This should be called only once, in init_3d_model, i.e. remove it here)
-!           CALL user_init_3d_model
-!           CALL location_message( 'finished', .TRUE. )
-
        ENDIF
-
-!-- Store initial chem spcs profile
-!         DO lsp = 1, nvar
-!          hom_cs(:,1,115,:) = SPREAD(  chem_species(lsp)%conc(:,nys,nxl), 2, statistic_regions+1 )
-!         ENDDO
-!
-!-- If required, change the surface chem spcs at the start of the 3D run
-       IF ( cs_surface_initial_change(1) /= 0.0_wp ) THEN            
-          DO lsp = 1, nspec 
-             chem_species(lsp)%conc(nzb,:,:) = chem_species(lsp)%conc(nzb,:,:) +  &
-                                               cs_surface_initial_change(lsp)
-          ENDDO
-       ENDIF 
-!
-!-- Initiale old and new time levels. 
-       DO lsp = 1, nvar
-          chem_species(lsp)%tconc_m = 0.0_wp                      
-          chem_species(lsp)%conc_p  = chem_species(lsp)%conc     
-       ENDDO
-
-    ENDIF
-
-
-
-!--- new code add above this line
-    DO lsp = 1, nphot
-       phot_frequen(lsp)%name = phot_names(lsp)
-!        IF( myid == 0 )  THEN
-!           WRITE(6,'(a,i4,3x,a)')  'Photolysis: ',lsp,trim(phot_names(lsp))
-!        ENDIF 
-         phot_frequen(lsp)%freq(nzb:nzt+1,nysg:nyng,nxlg:nxrg)    => freq_1(:,:,:,lsp)
-    ENDDO
-
-!--   Set initial values
-!    Not required any more, this can now be done with the namelist  by setting cs_surface 
-!    and cs_name without specifying cs_profile (Nevertheless, we still want to keep it for a while) 
-!   IF (  TRIM( initializing_actions ) /= 'read_restart_data' )  THEN             
-!         CALL set_const_initial_values
-!   ENDIF
-
-    RETURN
-
-    CONTAINS
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Subroutine setting constant initial values of chemical species
-!------------------------------------------------------------------------------!
-     SUBROUTINE set_const_initial_values
-!    Not required any more, this can now be done with the namelist  by setting cs_surface 
-!    and cs_name without specifying cs_profile (Nevertheless, we still want to keep it for a while) 
-         IMPLICIT   none
-
-!--      local variables
-         INTEGER                  :: lsp
-
-         IF(myid == 0)  THEN
-            write(6,'(/,a,/)')  ' chemics >>>> Set constant Initial Values: '
-         ENDIF
-
-!        Default values are taken from smog.def from supplied kpp example
-         DO lsp = 1, nspec
-            IF(trim(chem_species(lsp)%name) == 'NO')           THEN
-!              chem_species(lsp)%conc = 8.725*1.0E+08
-!              chem_species(lsp)%conc = 0.05_wp                          !added by bK
-               chem_species(lsp)%conc = 0.01_wp                          !added by RFo
-            ELSEIF (trim(chem_species(lsp)%name) == 'NO2')     THEN
-!              chem_species(lsp)%conc = 2.240*1.0E+08             
-!              chem_species(lsp)%conc = 0.01_wp                          !added by bK
-               chem_species(lsp)%conc = 0.05_wp                          !added by RFo
-            ELSEIF( trim( chem_species(lsp)%name ) == 'O3' )   THEN
-               chem_species(lsp)%conc = 0.05_wp                          !added by bK
-            ELSEIF(trim(chem_species(lsp)%name) == 'H2O')      THEN
-!              chem_species(lsp)%conc = 5.326*1.0E+11
-               chem_species(lsp)%conc = 1.30*1.0E+4_wp                   !added by bK
-            ELSEIF(trim(chem_species(lsp)%name) == 'O2')       THEN
-               chem_species(lsp)%conc = 2.0*1.0E+5_wp                    !added by bK
-            ELSEIF(trim(chem_species(lsp)%name) == 'RH')       THEN
-               chem_species(lsp)%conc = 0.001_wp                         !added by RFo
-            ELSEIF(trim(chem_species(lsp)%name) == 'CO')       THEN
-               chem_species(lsp)%conc = 0.5_wp                           !added by RFo
-            ELSEIF(trim(chem_species(lsp)%name) == 'RCHO')     THEN
-!              chem_species(lsp)%conc = 2.0_wp                           !added by bK
-               chem_species(lsp)%conc = 0.01_wp                          !added by RFo
-!           ELSEIF(trim(chem_species(lsp)%name) == 'OH')       THEN
-!              chem_species(lsp)%conc = 1.0*1.0E-07_wp                   !added by bK
-!           ELSEIF(trim(chem_species(lsp)%name) == 'HO2')      THEN
-!              chem_species(lsp)%conc = 1*1.0E-7_wp                      !added by bK
-!           ELSEIF(trim(chem_species(lsp)%name) == 'RCOO2')    THEN      ! corrected RFo
-!              chem_species(lsp)%conc = 1.0*1.0E-7_wp                    !added by bK
-!           ELSEIF(trim(chem_species(lsp)%name) == 'RCOO2NO2') THEN
-!              chem_species(lsp)%conc = 1.0*1.0E-7_wp                    !added by bK
-            ELSE
-!              H2O = 2.0e+04;
-               chem_species(lsp)%conc(nzb:nzt+1,nysg:nyng,nxlg:nxrg) = 0.0_wp
-            ENDIF
-
-            IF(myid == 0)  THEN
-               WRITE(6,'(a,3x,a,3x,a,e12.4)')  '   Species:     ',chem_species(lsp)%name(1:7), & 
-                                        'Initial Value = ',chem_species(lsp)%conc(nzb,nysg,nxlg)
-            ENDIF
-         ENDDO
-
-!   #if defined( __nopointer )
-!   !kk      Hier mit message abbrechen
-!            if(myid == 0)  then
-!               write(6,*)  '   KPP does only run with POINTER Version'
-!            end if
-!            stop 'error'
-!   #endif
-
-         RETURN
-      END SUBROUTINE set_const_initial_values
-
-
-   END SUBROUTINE chem_init
-!
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Subroutine defining parin for &chemistry_parameters for chemistry model
-!------------------------------------------------------------------------------!
-   SUBROUTINE chem_parin
-   
-      USE control_parameters,                                                  &
-          ONLY: air_chemistry
-          
-      USE chem_modules
-      
-      USE kinds
-
-      IMPLICIT   none
-
-      CHARACTER (LEN=80) ::  line   !< dummy string that contains the current line of the parameter file
-      
-      REAL(wp), DIMENSION(nmaxfixsteps) ::   my_steps   !< List of fixed timesteps   my_step(1) = 0.0 automatic stepping
-
-      NAMELIST /chemistry_parameters/   bc_cs_b,                          &
-                                        bc_cs_t,                          &
-                                        call_chem_at_all_substeps,        &
-                                        chem_debug0,                      &
-                                        chem_debug1,                      &
-                                        chem_debug2,                      &
-                                        chem_gasphase_on,                 &
-                                        cs_heights,                       &
-                                        cs_name,                          &
-                                        cs_profile,                       &
-                                        cs_profile_name,                  & 
-                                        cs_surface,                       &
-                                        emiss_factor_main,                &
-                                        emiss_factor_side,                &                      
-                                        icntrl,                           &
-                                        main_street_id,                   &
-                                        max_street_id,                    &
-                                        my_steps,                         &
-                                        nest_chemistry,                   &
-                                        rcntrl,                           &
-                                        side_street_id,                   &
-                                        photolysis_scheme,                &
-                                        wall_csflux,                      &
-                                        cs_vertical_gradient,             &
-                                        top_csflux,                       & 
-                                        surface_csflux,                   &
-                                        surface_csflux_name,              &
-                                        cs_surface_initial_change,        &
-                                        cs_vertical_gradient_level
-                             
-!-- analogue to chem_names(nspj) we could invent chem_surfaceflux(nspj) and chem_topflux(nspj)
-!-- so this way we could prescribe a specific flux value for each species
-!>  chemistry_parameters for initial profiles
-!>  cs_names = 'O3', 'NO2', 'NO', ...   to set initial profiles)
-!>  cs_heights(1,:) = 0.0, 100.0, 500.0, 2000.0, .... (height levels where concs will be prescribed for O3)
-!>  cs_heights(2,:) = 0.0, 200.0, 400.0, 1000.0, .... (same for NO2 etc.) 
-!>  cs_profiles(1,:) = 10.0, 20.0, 20.0, 30.0, .....  (chem spcs conc at height lvls chem_heights(1,:)) etc.
-!>  If the respective concentration profile should be constant with height, then use "cs_surface( number of spcs)"
-!>  then write these cs_surface values to chem_species(lsp)%conc_pr_init(:)
-
-!
-!--   Read chem namelist   
-!--   (todo: initialize these parameters in declaration part, do this for
-!--          all chemistry_parameters namelist parameters)
-      icntrl    = 0
-      rcntrl    = 0.0_wp
-      my_steps  = 0.0_wp
-      icntrl(2) = 1                                  
-      photolysis_scheme = 'simple'
-      atol = 1.0_wp
-      rtol = 0.01_wp
-!
-!--   Try to find chemistry package
-      REWIND ( 11 )
-      line = ' '
-      DO WHILE ( INDEX( line, '&chemistry_parameters' ) == 0 )
-         READ ( 11, '(A)', END=20 )  line
-      ENDDO
-      BACKSPACE ( 11 )
-!
-!--   Read chemistry namelist
-      READ ( 11, chemistry_parameters, ERR = 10, END = 20 )
-!
-!--   Enable chemistry model
-      air_chemistry = .TRUE.
-      GOTO 20
-
- 10   BACKSPACE( 11 )
-      READ( 11 , '(A)') line
-      CALL parin_fail_message( 'chemistry_parameters', line )
-
- 20   CONTINUE
-
-      t_steps = my_steps          !(todo: Why not directly make t_steps a
-                                  !       namelist parameter?)
-
-   END SUBROUTINE chem_parin
-
- !
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Subroutine to integrate chemical species in the given chemical mechanism
-!------------------------------------------------------------------------------!
-
-   SUBROUTINE chem_integrate_ij (i, j)
-
-      USE cpulog,                                                              &
-           ONLY: cpu_log, log_point
-      USE statistics,                                                          &   ! ## RFo
-           ONLY:  weight_pres
-       USE control_parameters,                                                 &   ! ## RFo 
-           ONLY:  dt_3d, intermediate_timestep_count
-
-      IMPLICIT   none
-      INTEGER,INTENT(IN)       :: i,j
-
-!--   local variables
-      INTEGER(iwp) ::  lsp                                                          !< running index for chem spcs.
-      INTEGER(iwp) ::  lph                                                          !< running index for photolysis frequencies
-      INTEGER                  :: istatf
-      INTEGER,dimension(20)    :: istatus
-      REAL(kind=wp),dimension(nzb+1:nzt,nspec)                :: tmp_conc           
-      REAL(kind=wp),dimension(nzb+1:nzt)                      :: tmp_temp
-      REAL(kind=wp),dimension(nzb+1:nzt,nphot)                :: tmp_phot
-      REAL(kind=wp),dimension(nzb+1:nzt)                      :: tmp_fact   
-     REAL(kind=wp),dimension(nzb+1:nzt)                      :: tmp_fact_i    !< conversion factor between molecules cm^{-3} and ppm
-     REAL(wp)                         ::  conv                                !< conversion factor
-     REAL(wp), PARAMETER              ::  ppm2fr  = 1.0e-6_wp                 !< Conversion factor ppm to fraction
-     REAL(wp), PARAMETER              ::  t_std   = 273.15_wp                 !< standard pressure (Pa)
-     REAL(wp), PARAMETER              ::  p_std   = 101325.0_wp               !< standard pressure (Pa)
-     REAL(wp), PARAMETER              ::  vmolcm  = 22.414e3_wp               !< Mole volume (22.414 l) in cm^{-3}
-     REAL(wp), PARAMETER              ::  xna     = 6.022e23_wp               !< Avogadro number (molecules/mol)
-
-
-      REAL(kind=wp)  :: dt_chem                                             
-
-       CALL cpu_log( log_point(80), '[chem_integrate_ij]', 'start' )
-!<     Set chem_gasphase_on to .FALSE. if you want to skip computation of gas phase chemistry
-    IF (chem_gasphase_on) THEN
-
-       tmp_temp(:) = pt(:,j,i) * exner(nzb+1:nzt)
-! ppm to molecules/cm**3
-!      tmp_fact = 1.e-6_wp*6.022e23_wp/(22.414_wp*1000._wp) * 273.15_wp * hyp(nzb+1:nzt)/( 101300.0_wp * tmp_temp )
-       conv = ppm2fr * xna / vmolcm
-       tmp_fact(:) = conv * t_std * hyp(nzb+1:nzt) / (tmp_temp(:) * p_std)
-       tmp_fact_i = 1.0_wp/tmp_fact
-
-       CALL fill_temp (istatf, tmp_temp)                                      !< Load constant temperature into kpp context
-!      CALL fill_temp (istatf, pt(nzb+1:nzt,j,i))                             !< Load temperature into kpp context
-
-       DO lsp = 1,nspec
-          tmp_conc(:,lsp) = chem_species(lsp)%conc(nzb+1:nzt,j,i) * tmp_fact(:) 
-       ENDDO
-
-       DO lph = 1,nphot
-          tmp_phot(:,lph) = phot_frequen(lph)%freq(nzb+1:nzt,j,i)               
-       ENDDO
-
-       IF(myid == 0 .AND. chem_debug0 ) THEN
-          IF (i == 10 .and. j == 10) WRITE(0,*) 'begin chemics step ',dt_3d
-       ENDIF
-
-!--    Compute length of time step     # RFo
-       IF ( call_chem_at_all_substeps )  THEN
-          dt_chem = dt_3d * weight_pres(intermediate_timestep_count)
-       ELSE
-          dt_chem = dt_3d
-       ENDIF
-
-       CALL cpu_log( log_point(81), '{chem_gasphase_integrate}', 'start' )
-
-
-       CALL chem_gasphase_integrate (dt_chem, tmp_conc, tmp_temp, tmp_phot, istatus=istatus)
-
-
-       CALL cpu_log( log_point(81), '{chem_gasphase_integrate}', 'stop' )
-
-       DO lsp = 1,nspec
-          chem_species(lsp)%conc (nzb+1:nzt,j,i) = tmp_conc(:,lsp) * tmp_fact_i(:)  ! RFo
-       ENDDO
-
-!      IF (myid == 0 .AND. chem_debug2 ) THEN 
-!         IF (i == 10 .and. j == 10)   WRITE(6,'(a,8i7)') ' KPP Status ',istatus(1:8)
-!         write(6,'(a,8i7)') ' KPP Status ',istatus(1:8)
-!      ENDIF
-
-    ENDIF
-       CALL cpu_log( log_point(80), '[chem_integrate_ij]', 'stop' )
-
-       RETURN
-   END SUBROUTINE chem_integrate_ij
-!
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Subroutine for swapping of timelevels for chemical species
-!> called out from subroutine swap_timelevel
-!------------------------------------------------------------------------------!
-
-   SUBROUTINE chem_swap_timelevel (level)
-      IMPLICIT   none
-
-      INTEGER,INTENT(IN)                  :: level
-
-!--   local variables
-
-      INTEGER               :: lsp
-
-!        print*,' *** entering chem_swap_timelevel ***) '
-      if(level == 0)  then
-         do lsp=1, nvar                                       
-            chem_species(lsp)%conc(nzb:nzt+1,nysg:nyng,nxlg:nxrg)    => spec_conc_1(:,:,:,lsp)
-            chem_species(lsp)%conc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)  => spec_conc_2(:,:,:,lsp)
-         end do
-      else
-         do lsp=1, nvar                                        
-            chem_species(lsp)%conc(nzb:nzt+1,nysg:nyng,nxlg:nxrg)    => spec_conc_2(:,:,:,lsp)
-            chem_species(lsp)%conc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)  => spec_conc_1(:,:,:,lsp)
-         end do
-      end if
-
-      RETURN
-   END SUBROUTINE chem_swap_timelevel
-
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Subroutine defining appropriate grid for netcdf variables.
-!> It is called out from subroutine netcdf.
-!------------------------------------------------------------------------------!
-   SUBROUTINE chem_define_netcdf_grid( var, found, grid_x, grid_y, grid_z )
-
-      IMPLICIT NONE
-
-      CHARACTER (LEN=*), INTENT(IN)  ::  var         !<
-      LOGICAL, INTENT(OUT)           ::  found       !<
-      CHARACTER (LEN=*), INTENT(OUT) ::  grid_x      !<
-      CHARACTER (LEN=*), INTENT(OUT) ::  grid_y      !<
-      CHARACTER (LEN=*), INTENT(OUT) ::  grid_z      !<
-
-      found  = .TRUE.
-
-      if(var(1:3) == 'kc_')   then                    !< always the same grid for chemistry variables
-            grid_x = 'x'
-            grid_y = 'y'
-            grid_z = 'zu'                             !< kk Use same z axis as u variables. Has to be checked if OK
-      else
-            found  = .FALSE.
-            grid_x = 'none'
-            grid_y = 'none'
-            grid_z = 'none'
-      end if
-
-!     write(6,*) 'chem_define_netcdf_grid ',TRIM(var),' ',trim(grid_x),' ',found
-
-   END SUBROUTINE chem_define_netcdf_grid
-!
+    END SUBROUTINE chem_boundary_conds_decycle
+   !
 !------------------------------------------------------------------------------!
 !
